package net.t2code.alias.Spigot.config.config;

import net.t2code.alias.Spigot.Main;
import net.t2code.alias.Util;
import net.t2code.t2codelib.SPIGOT.api.messages.T2Csend;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2Cconfig;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;

public class CreateConfig {


    public static void configCreate() {
        long long_ = System.currentTimeMillis();
        if (new File(Main.getPath(), "config.yml").exists()) {
            if (Main.getPlugin().getConfig().getBoolean("Plugin.Debug")) T2Csend.console(Util.getPrefix() + " §5DEBUG: §6" + " §4config.yml are created / updated...");
        } else T2Csend.console(Util.getPrefix() + " §4config.yml are created...");

        File config = new File(Main.getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);


        if (yamlConfiguration.contains("ConfigVersion") && yamlConfiguration.getInt("ConfigVersion") < 4) {
            convert();
            return;
        }

        T2Cconfig.set("plugin.language", "english", yamlConfiguration);
        T2Cconfig.set("plugin.updateCheck.onJoin", true, yamlConfiguration);
        T2Cconfig.set("plugin.updateCheck.seePreReleaseUpdates", true, yamlConfiguration);
        T2Cconfig.set("plugin.updateCheck.timeInterval", 60, yamlConfiguration);

        T2Cconfig.set("buy.message", true, yamlConfiguration);
        T2Cconfig.set("subAlias.tabComplete", true, yamlConfiguration);

        try {
            yamlConfiguration.save(config);
        } catch (IOException e) {
            e.printStackTrace();
        }
        T2Csend.console(Util.getPrefix() + " §2config.yml were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }

    private static void convert() {
        File configOld = new File(Main.getPath(), "config.yml");
        configOld.renameTo(new File(Main.getPath(), "configV3.yml"));
        YamlConfiguration yamlConfigurationOld = YamlConfiguration.loadConfiguration(configOld);

        File config = new File(Main.getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        T2Cconfig.set("plugin.language", yamlConfigurationOld.getString("Plugin.language"), yamlConfiguration);
        T2Cconfig.set("plugin.updateCheck.onJoin", yamlConfigurationOld.getBoolean("Plugin.updateCheck.onJoin"), yamlConfiguration);
        T2Cconfig.set("plugin.updateCheck.seePreReleaseUpdates", yamlConfigurationOld.getBoolean("Plugin.updateCheck.seePreReleaseUpdates"), yamlConfiguration);
        T2Cconfig.set("plugin.updateCheck.timeInterval", yamlConfigurationOld.getInt("Plugin.updateCheck.timeInterval"), yamlConfiguration);

        T2Cconfig.set("buy.message", yamlConfigurationOld.getBoolean("Buy.Message"), yamlConfiguration);
        T2Cconfig.set("subAlias.tabComplete", yamlConfigurationOld.getBoolean("SubAlias.TabComplete"), yamlConfiguration);

        try {
            yamlConfiguration.save(config);
        } catch (IOException e) {
            e.printStackTrace();
        }

        configCreate();
    }
}
